## hashcash 0.32

=== Makefile ===
HC_VERS = 0.32
INSTALL_PATH = /usr/bin
MAN_INSTALL_PATH = /usr/share/man/man1
DOC_INSTALL_PATH = /usr/share/doc/hashcash-$(HC_VERS)
MAKEDEPEND = makedepend
COPT = -O 
OPT = -DREGEXP_POSIX
# if no POSIX regexp support, try BSD
# OPT = -DREGEXP_BSD
# if no POSIX or BSD, disable, still have builtin basic wildcard support
# OPT = -O
LDFLAGS = $(CARCH)
CFLAGS = $(COPT) $(OPT) $(CWARN) $(CARCH)
EXES = hashcash sha1 sha1test
INSTALL = /usr/bin/install
POD2MAN = pod2man
POD2HTML = pod2html
POD2TEXT = pod2text
DELETE = /bin/rm -f
ETAGS = etags
OBJS = hashcash.o libsha1.o libhc.o timer.o sdb.o utct.o random.o lock.o
DIST = ../dist.csh

build:	hashcash sha1

hashcash:	$(OBJS)
	$(CC) $(LDFLAGS) $(OBJS) -o $@

sha1:	sha1.o libsha1.o
	$(CC) $(LDFLAGS) sha1.o libsha1.o -o $@

sha1test:	sha1test.o libsha1.o timer.o
	$(CC) $(LDFLAGS) sha1test.o libsha1.o timer.o -o $@

all:	$(EXES)

docs:	hashcash.1 hashcash.html hashcash.txt sha1-hashcash.1 \
sha1-hashcash.html sha1-hashcash.txt

hashcash.1:	hashcash.pod
	$(POD2MAN) -s 1 -c hashcash -r $(HC_VERS) $? > $@

hashcash.html:	hashcash.pod
	$(POD2HTML) --title hashcash $? > $@
	$(DELETE) pod2htm*

hashcash.txt: hashcash.pod
	$(POD2TEXT) $? > $@

sha1-hashcash.1:	sha1-hashcash.pod
	$(POD2MAN) -s 1 -c sha1 -r $(HC_VERS) $? > $@

sha1-hashcash.html:	sha1-hashcash.pod
	$(POD2HTML) --title sha1 $? > $@
	$(DELETE) pod2htm*

sha1-hashcash.txt: sha1-hashcash.pod
	$(POD2TEXT) $? > $@

install:	hashcash sha1 hashcash.1 sha1-hashcash.1
	$(INSTALL) -d $(INSTALL_PATH)
	$(INSTALL) hashcash sha1 $(INSTALL_PATH)
	$(INSTALL) -d $(MAN_INSTALL_PATH)
	$(INSTALL) -m 644 hashcash.1 sha1-hashcash.1 $(MAN_INSTALL_PATH)
	$(INSTALL) -d $(DOC_INSTALL_PATH)
	$(INSTALL) -m 644 README LICENSE CHANGELOG $(DOC_INSTALL_PATH)

depend:
	$(MAKEDEPEND) -- -Y *.c *.h

docclean:
	$(DELETE) hashcash.txt hashcash.1 hashcash.html pod2htm*
	$(DELETE) sha1-hashcash.txt sha1-hashcash.1 sha1-hashcash.html

clean:
	$(DELETE) *.o *~

distclean:
	$(DELETE) *.o *~ $(EXES) *.db *.bak TAGS core* *.bak test/*

tags:
	$(ETAGS) *.c *.h

dist:	
	$(DIST)

# DO NOT DELETE

getopt.o: getopt.h
hashcash.o: sdb.h utct.h random.h timer.h types.h hashcash.h sha1.h
libhc.o: hashcash.h utct.h types.h sha1.h random.h timer.h
libsha1.o: sha1.h types.h
lock.o: lock.h
random.o: random.h timer.h types.h sha1.h
sdb.o: sdb.h types.h utct.h lock.h
sha1.o: sha1.h types.h
sha1test.o: sha1.h types.h timer.h
timer.o: timer.h types.h
utct.o: utct.h
hashcash.o: utct.h types.h
sha1.o: types.h
timer.o: types.h

## hashcash 1.13

=== Makefile ===
HC_VERS = 1.13
CHANGEME1 = 1 # put PACKAGER = EBUILD|RPM etc here
CHANGEME2 = 2
CHANGEME3 = 3
INSTALL_PATH = /usr/bin
MAN_INSTALL_PATH = /usr/share/man/man1
DOC_INSTALL_PATH = /usr/share/doc/hashcash-$(HC_VERS)
MAKEDEPEND = makedepend
MSLIB = mslib 
# here you can choose the regexp style your system has
# default is POSIX
# 	CFLAGS = -DREGEXP_POSIX
# if no POSIX regexp support, try BSD
# 	CFLAGS = -DREGEXP_BSD
# if no POSIX or BSD, disable, still have builtin basic wildcard support
# 	CFLAGS = 
COPT_GENERIC = -O3
COPT_GNU = -O3 -funroll-loops
COPT_X86 = -O3 -funroll-loops -march=i386 -mcpu=pentium -mmmx \
	-D_REENTRANT -D_THREAD_SAFE -fPIC
COPT_MINGW = -O3 -funroll-loops -march=i386 -mcpu=pentium -mmmx \
        -D_REENTRANT -D_THREAD_SAFE
COPT_G3_OSX = -O3 -funroll-loops -fno-inline -mcpu=750 -faltivec
COPT_PPC_LINUX = -O3 -funroll-loops -fno-inline -mcpu=604e -maltivec \
	-mabi=altivec
CFLAGS = -DREGEXP_POSIX
EXES = hashcash$(EXE) sha1$(EXE) sha1test$(EXE)
INSTALL = install
POD2MAN = pod2man
POD2HTML = pod2html
POD2TEXT = pod2text
DELETE = rm -f
ETAGS = etags
FASTLIBS = libfastmint.o fastmint_mmx_standard_1.o fastmint_mmx_compact_1.o \
	fastmint_ansi_compact_1.o fastmint_ansi_standard_1.o \
	fastmint_ansi_compact_2.o fastmint_ansi_standard_2.o \
	fastmint_altivec_standard_1.o fastmint_altivec_standard_2.o \
	fastmint_altivec_compact_2.o fastmint_ansi_ultracompact_1.o
OBJS = hashcash.o libsha1.o libhc.o sdb.o lock.o utct.o random.o sstring.o \
	getopt.o $(FASTLIBS)
DLLOBJS = libhc.o libsha1.o utct.o sdb.o lock.o sstring.o random.o $(FASTLIBS)
EXEOBJS = hashcash.o

DIST = ../dist.csh

default:	help generic

help:
	@echo "make <platform> where platform is:"
	@echo "    x86, mingw, mingw-dll, g3-osx, ppc-linux, gnu, generic"
	@echo "other make targets are docs, install, clean, distclean, docclean"
	@echo ""
	@echo "(doing make generic by default)"
	@echo ""

generic:
	$(MAKE) "CFLAGS=$(CFLAGS) $(COPT_GENERIC) $(COPT)" build

gnu:
	$(MAKE) "CFLAGS=$(CFLAGS) $(COPT_GNU) $(COPT)" "CC=gcc" build

x86: 
	$(MAKE) "CFLAGS=$(CFLAGS) $(COPT_X86) $(COPT)" build

mingw: 
	$(MAKE) "CC=gcc" "EXE=.exe" "CFLAGS=$(COPT_MINGW) -DMONOLITHIC $(COPT)" build

mingw-dll:
	$(MAKE) "CC=gcc" "EXE=.exe" "CFLAGS=$(COPT_MINGW) $(COPT)" build-dll

g3-osx:
	$(MAKE) "CFLAGS=$(CFLAGS) $(COPT_G3_OSX) $(COPT)" build

ppc-linux:
	$(MAKE) "CFLAGS=$(CFLAGS) $(COPT_PPC_LINUX) $(COPT)" build

build:	hashcash$(EXE) sha1$(EXE)

build-dll:      hashcash-dll$(EXE) sha1$(EXE)

hashcash$(EXE):	$(OBJS)
	$(CC) $(LDFLAGS) $(OBJS) -o $@

sha1$(EXE):	sha1.o libsha1.o
	$(CC) $(LDFLAGS) sha1.o libsha1.o -o $@

hashcash-dll$(EXE):   $(EXEOBJS) hashcash.dll
	$(CC) $(LDFLAGS) $(EXEOBJS) hashcash.dll -o $@

sha1test$(EXE):	sha1test.o libsha1.o
	$(CC) $(LDFLAGS) sha1test.o libsha1.o -o $@

all:	$(EXES)

hashcash.dll:   hashcash.def $(DLLOBJS)
	$(CC) -shared -o hashcash.dll $(DLLOBJS) \
	-Wl,--output-def,hashcash.def,--out-implib,libhashcash.a
	$(MSLIB) /machine:x86 /def:hashcash.def

docs:	hashcash.1 hashcash.html hashcash.txt sha1-hashcash.1 \
	sha1-hashcash.html sha1-hashcash.txt

hashcash.1:	hashcash.pod
	$(POD2MAN) -s 1 -c hashcash -r $(HC_VERS) $? > $@

hashcash.html:	hashcash.pod
	$(POD2HTML) --title hashcash $? > $@
	$(DELETE) pod2htm*

hashcash.txt: hashcash.pod
	$(POD2TEXT) $? > $@

sha1-hashcash.1:	sha1-hashcash.pod
	$(POD2MAN) -s 1 -c sha1 -r $(HC_VERS) $? > $@

sha1-hashcash.html:	sha1-hashcash.pod
	$(POD2HTML) --title sha1 $? > $@
	$(DELETE) pod2htm*

sha1-hashcash.txt: sha1-hashcash.pod
	$(POD2TEXT) $? > $@

install:	hashcash sha1 hashcash.1 sha1-hashcash.1
	$(INSTALL) -d $(INSTALL_PATH)
	$(INSTALL) hashcash sha1 $(INSTALL_PATH)
	$(INSTALL) -d $(MAN_INSTALL_PATH)
	$(INSTALL) -m 644 hashcash.1 sha1-hashcash.1 $(MAN_INSTALL_PATH)
	$(INSTALL) -d $(DOC_INSTALL_PATH)
	$(INSTALL) -m 644 README LICENSE CHANGELOG $(DOC_INSTALL_PATH)

depend:
	$(MAKEDEPEND) -- -Y *.c *.h

docclean:
	$(DELETE) hashcash.txt hashcash.1 hashcash.html pod2htm*
	$(DELETE) sha1-hashcash.txt sha1-hashcash.1 sha1-hashcash.html

clean:
	$(DELETE) *.o *~

distclean:
	$(DELETE) *.o *~ $(EXES) hashcash-dll.* *.db *.bak TAGS core* 
	$(DELETE) *.bak test/* *.dll *.lib *.exe *.a

tags:
	$(ETAGS) *.c *.h

dist:	
	$(DIST)

# DO NOT DELETE

fastmint_altivec_compact_2.o: libfastmint.h hashcash.h
fastmint_altivec_standard_1.o: libfastmint.h hashcash.h
fastmint_altivec_standard_2.o: libfastmint.h hashcash.h
fastmint_ansi_compact_1.o: libfastmint.h hashcash.h
fastmint_ansi_compact_2.o: libfastmint.h hashcash.h
fastmint_ansi_standard_1.o: libfastmint.h hashcash.h
fastmint_ansi_standard_2.o: libfastmint.h hashcash.h
fastmint_ansi_ultracompact_1.o: libfastmint.h hashcash.h
fastmint_mmx_compact_1.o: libfastmint.h hashcash.h
fastmint_mmx_standard_1.o: libfastmint.h hashcash.h
getopt.o: getopt.h
hashcash.o: sdb.h utct.h random.h hashcash.h libfastmint.h sstring.h getopt.h
hashcash.o: sha1.h types.h
libfastmint.o: random.h sha1.h types.h libfastmint.h hashcash.h
libhc.o: hashcash.h utct.h libfastmint.h sha1.h types.h random.h sstring.h
libsha1.o: sha1.h types.h
lock.o: lock.h
random.o: random.h sha1.h types.h
sdb.o: types.h lock.h sdb.h utct.h
sha1.o: sha1.h types.h
sha1test.o: sha1.h types.h
sstring.o: sstring.h
utct.o: sstring.h utct.h
libfastmint.o: hashcash.h
sha1.o: types.h

## hashcash 1.17

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-HC_VERS = 1.13
+HC_VERS = 1.17
 CHANGEME1 = 1 # put PACKAGER = EBUILD|RPM etc here
 CHANGEME2 = 2
 CHANGEME3 = 3
@@ -9,11 +9,12 @@
 MSLIB = mslib 
 # here you can choose the regexp style your system has
 # default is POSIX
-# 	CFLAGS = -DREGEXP_POSIX
+# 	REGEXP = -DREGEXP_POSIX
 # if no POSIX regexp support, try BSD
-# 	CFLAGS = -DREGEXP_BSD
+# 	REGEXP = -DREGEXP_BSD
 # if no POSIX or BSD, disable, still have builtin basic wildcard support
-# 	CFLAGS = 
+# 	REGEXP = 
+COPT_DEBUG = -g
 COPT_GENERIC = -O3
 COPT_GNU = -O3 -funroll-loops
 COPT_X86 = -O3 -funroll-loops -march=i386 -mcpu=pentium -mmmx \
@@ -23,7 +24,8 @@
 COPT_G3_OSX = -O3 -funroll-loops -fno-inline -mcpu=750 -faltivec
 COPT_PPC_LINUX = -O3 -funroll-loops -fno-inline -mcpu=604e -maltivec \
 	-mabi=altivec
-CFLAGS = -DREGEXP_POSIX
+REGEXP=-DREGEXP_POSIX
+LIB=.a
 EXES = hashcash$(EXE) sha1$(EXE) sha1test$(EXE)
 INSTALL = install
 POD2MAN = pod2man
@@ -35,10 +37,11 @@
 	fastmint_ansi_compact_1.o fastmint_ansi_standard_1.o \
 	fastmint_ansi_compact_2.o fastmint_ansi_standard_2.o \
 	fastmint_altivec_standard_1.o fastmint_altivec_standard_2.o \
-	fastmint_altivec_compact_2.o fastmint_ansi_ultracompact_1.o
-OBJS = hashcash.o libsha1.o libhc.o sdb.o lock.o utct.o random.o sstring.o \
+	fastmint_altivec_compact_2.o fastmint_ansi_ultracompact_1.o \
+	fastmint_library.o
+OBJS = libsha1.o libhc.o sdb.o lock.o utct.o random.o sstring.o \
 	getopt.o $(FASTLIBS)
-DLLOBJS = libhc.o libsha1.o utct.o sdb.o lock.o sstring.o random.o $(FASTLIBS)
+LIBOBJS = libhc.o libsha1.o utct.o sdb.o lock.o sstring.o random.o $(FASTLIBS)
 EXEOBJS = hashcash.o
 
 DIST = ../dist.csh
@@ -47,53 +50,90 @@
 
 help:
 	@echo "make <platform> where platform is:"
-	@echo "    x86, mingw, mingw-dll, g3-osx, ppc-linux, gnu, generic"
+	@echo "    x86, mingw, mingw-dll, g3-osx, ppc-linux, gnu, generic, debug"
+	@echo "or to link with openSSL for SHA1 rather than builtin:"
+	@echo "    x86-openssl, g3-osx-openssl, ppc-linux-openssl, "
+	@echo "    gnu-openssl, generic-openssl, debug-openssl"
 	@echo "other make targets are docs, install, clean, distclean, docclean"
 	@echo ""
 	@echo "(doing make generic by default)"
 	@echo ""
 
 generic:
-	$(MAKE) "CFLAGS=$(CFLAGS) $(COPT_GENERIC) $(COPT)" build
+	$(MAKE) "CFLAGS=$(CFLAGS) $(REGEXP) $(COPT_GENERIC) $(COPT)" build
+
+debug:
+	$(MAKE) "CFLAGS=$(CFLAGS) $(REGEXP) $(COPT_DEBUG) $(COPT)" build
 
 gnu:
-	$(MAKE) "CFLAGS=$(CFLAGS) $(COPT_GNU) $(COPT)" "CC=gcc" build
+	$(MAKE) "CFLAGS=$(CFLAGS) $(REGEXP) $(COPT_GNU) $(COPT)" "CC=gcc" build
 
 x86: 
-	$(MAKE) "CFLAGS=$(CFLAGS) $(COPT_X86) $(COPT)" build
+	$(MAKE) "CFLAGS=$(CFLAGS) $(REGEXP) $(COPT_X86) $(COPT)" build
+
+g3-osx:
+	$(MAKE) "CFLAGS=$(CFLAGS) $(REGEXP) $(COPT_G3_OSX) $(COPT)" build
+
+ppc-linux:
+	$(MAKE) "CFLAGS=$(CFLAGS) $(REGEXP) $(COPT_PPC_LINUX) $(COPT)" build
+
+# mingw windows targets (cross compiler, or native)
 
 mingw: 
-	$(MAKE) "CC=gcc" "EXE=.exe" "CFLAGS=$(COPT_MINGW) -DMONOLITHIC $(COPT)" build
+	$(MAKE) "LIB=.lib" "CC=gcc" "EXE=.exe" "CFLAGS=$(COPT_MINGW) -DMONOLITHIC $(COPT)" build
 
 mingw-dll:
 	$(MAKE) "CC=gcc" "EXE=.exe" "CFLAGS=$(COPT_MINGW) $(COPT)" build-dll
 
-g3-osx:
-	$(MAKE) "CFLAGS=$(CFLAGS) $(COPT_G3_OSX) $(COPT)" build
-
-ppc-linux:
-	$(MAKE) "CFLAGS=$(CFLAGS) $(COPT_PPC_LINUX) $(COPT)" build
+
+# openSSL versions of targets
+
+x86-openssl:
+	$(MAKE) x86 "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) -lcrypto"
+
+g3-osx-openssl:
+	$(MAKE) g3-osx "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) -lcrypto"
+
+ppc-linux-openssl:
+	$(MAKE) ppc-linux "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) -lcrypto"
+
+gnu-openssl:
+	$(MAKE) gnu "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) -lcrypto"
+
+generic-openssl:
+	$(MAKE) generic "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) -lcrypto"
+
+debug-openssl:
+	$(MAKE) debug "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) -lcrypto"
+
 
 build:	hashcash$(EXE) sha1$(EXE)
 
 build-dll:      hashcash-dll$(EXE) sha1$(EXE)
 
-hashcash$(EXE):	$(OBJS)
-	$(CC) $(LDFLAGS) $(OBJS) -o $@
+hashcash$(EXE):	hashcash.o getopt.o libhashcash$(LIB) 
+	$(CC) hashcash.o getopt.o libhashcash$(LIB) -o $@ $(LDFLAGS)
 
 sha1$(EXE):	sha1.o libsha1.o
-	$(CC) $(LDFLAGS) sha1.o libsha1.o -o $@
+	$(CC) sha1.o libsha1.o -o $@ $(LDFLAGS)
+
+example$(EXE):	example.o getopt.o libhashcash$(LIB)
+	$(CC) example.o getopt.o libhashcash$(LIB) -o $@ $(LDFLAGS)
 
 hashcash-dll$(EXE):   $(EXEOBJS) hashcash.dll
-	$(CC) $(LDFLAGS) $(EXEOBJS) hashcash.dll -o $@
+	$(CC) $(EXEOBJS) hashcash.dll -o $@ $(LDFLAGS)
 
 sha1test$(EXE):	sha1test.o libsha1.o
-	$(CC) $(LDFLAGS) sha1test.o libsha1.o -o $@
+	$(CC) sha1test.o libsha1.o -o $@ $(LDFLAGS)
 
 all:	$(EXES)
 
-hashcash.dll:   hashcash.def $(DLLOBJS)
-	$(CC) -shared -o hashcash.dll $(DLLOBJS) \
+libhashcash$(LIB):	$(LIBOBJS)
+	$(DELETE) $@
+	$(AR) rcs $@ $(LIBOBJS)
+
+hashcash.dll:   $(LIBOBJS)
+	$(CC) -shared -o hashcash.dll $(LIBOBJS) \
 	-Wl,--output-def,hashcash.def,--out-implib,libhashcash.a
 	$(MSLIB) /machine:x86 /def:hashcash.def
 
@@ -150,6 +190,7 @@
 
 # DO NOT DELETE
 
+example.o: sstring.h sdb.h hashcash.h getopt.h
 fastmint_altivec_compact_2.o: libfastmint.h hashcash.h
 fastmint_altivec_standard_1.o: libfastmint.h hashcash.h
 fastmint_altivec_standard_2.o: libfastmint.h hashcash.h
@@ -158,6 +199,7 @@
 fastmint_ansi_standard_1.o: libfastmint.h hashcash.h
 fastmint_ansi_standard_2.o: libfastmint.h hashcash.h
 fastmint_ansi_ultracompact_1.o: libfastmint.h hashcash.h
+fastmint_library.o: sha1.h types.h libfastmint.h hashcash.h
 fastmint_mmx_compact_1.o: libfastmint.h hashcash.h
 fastmint_mmx_standard_1.o: libfastmint.h hashcash.h
 getopt.o: getopt.h

## hashcash 1.21

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-HC_VERS = 1.17
+HC_VERS = 1.21
 CHANGEME1 = 1 # put PACKAGER = EBUILD|RPM etc here
 CHANGEME2 = 2
 CHANGEME3 = 3
@@ -14,18 +14,20 @@
 # 	REGEXP = -DREGEXP_BSD
 # if no POSIX or BSD, disable, still have builtin basic wildcard support
 # 	REGEXP = 
+REGEXP=-DREGEXP_POSIX
 COPT_DEBUG = -g
 COPT_GENERIC = -O3
 COPT_GNU = -O3 -funroll-loops
-COPT_X86 = -O3 -funroll-loops -march=i386 -mcpu=pentium -mmmx \
+COPT_X86 = -O3 -funroll-loops -march=pentium-mmx -mmmx \
 	-D_REENTRANT -D_THREAD_SAFE -fPIC
-COPT_MINGW = -O3 -funroll-loops -march=i386 -mcpu=pentium -mmmx \
+COPT_MINGW = -O3 -funroll-loops -march=pentium-mmx -mmmx \
         -D_REENTRANT -D_THREAD_SAFE
 COPT_G3_OSX = -O3 -funroll-loops -fno-inline -mcpu=750 -faltivec
 COPT_PPC_LINUX = -O3 -funroll-loops -fno-inline -mcpu=604e -maltivec \
 	-mabi=altivec
-REGEXP=-DREGEXP_POSIX
 LIB=.a
+# request static link of -lcrypto only
+LIBCRYPTO=/usr/lib/libcrypto.a
 EXES = hashcash$(EXE) sha1$(EXE) sha1test$(EXE)
 INSTALL = install
 POD2MAN = pod2man
@@ -79,7 +81,7 @@
 
 # mingw windows targets (cross compiler, or native)
 
-mingw: 
+mingw:
 	$(MAKE) "LIB=.lib" "CC=gcc" "EXE=.exe" "CFLAGS=$(COPT_MINGW) -DMONOLITHIC $(COPT)" build
 
 mingw-dll:
@@ -89,22 +91,22 @@
 # openSSL versions of targets
 
 x86-openssl:
-	$(MAKE) x86 "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) -lcrypto"
+	$(MAKE) x86 "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) $(LIBCRYPTO)"
 
 g3-osx-openssl:
-	$(MAKE) g3-osx "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) -lcrypto"
+	$(MAKE) g3-osx "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) $(LIBCRYPTO)"
 
 ppc-linux-openssl:
-	$(MAKE) ppc-linux "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) -lcrypto"
+	$(MAKE) ppc-linux "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) $(LIBCRYPTO)"
 
 gnu-openssl:
-	$(MAKE) gnu "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) -lcrypto"
+	$(MAKE) gnu "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) $(LIBCRYPTO)"
 
 generic-openssl:
-	$(MAKE) generic "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) -lcrypto"
+	$(MAKE) generic "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) $(LIBCRYPTO)"
 
 debug-openssl:
-	$(MAKE) debug "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) -lcrypto"
+	$(MAKE) debug "CFLAGS=$(CFLAGS) -DOPENSSL" "LDFLAGS=$(LDFLAGS) $(LIBCRYPTO)"
 
 
 build:	hashcash$(EXE) sha1$(EXE)
@@ -180,7 +182,7 @@
 
 distclean:
 	$(DELETE) *.o *~ $(EXES) hashcash-dll.* *.db *.bak TAGS core* 
-	$(DELETE) *.bak test/* *.dll *.lib *.exe *.a
+	$(DELETE) *.bak test/* *.dll *.lib *.exe *.a *.sdb
 
 tags:
 	$(ETAGS) *.c *.h

## hashcash 1.22

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-HC_VERS = 1.21
+HC_VERS = 1.22
 CHANGEME1 = 1 # put PACKAGER = EBUILD|RPM etc here
 CHANGEME2 = 2
 CHANGEME3 = 3
@@ -15,7 +15,7 @@
 # if no POSIX or BSD, disable, still have builtin basic wildcard support
 # 	REGEXP = 
 REGEXP=-DREGEXP_POSIX
-COPT_DEBUG = -g
+COPT_DEBUG = -g -DDEBUG
 COPT_GENERIC = -O3
 COPT_GNU = -O3 -funroll-loops
 COPT_X86 = -O3 -funroll-loops -march=pentium-mmx -mmmx \
@@ -120,7 +120,7 @@
 	$(CC) sha1.o libsha1.o -o $@ $(LDFLAGS)
 
 example$(EXE):	example.o getopt.o libhashcash$(LIB)
-	$(CC) example.o getopt.o libhashcash$(LIB) -o $@ $(LDFLAGS)
+	$(CC) example.o getopt.o libhashcash$(LIB) $(LIBCRYPTO) -o $@ $(LDFLAGS) 
 
 hashcash-dll$(EXE):   $(EXEOBJS) hashcash.dll
 	$(CC) $(EXEOBJS) hashcash.dll -o $@ $(LDFLAGS)

=== debian/changelog ===
hashcash (1.22-1) unstable; urgency=medium

  * New maintainer. (Closes: #831803)
    Thanks to Hubert Chan for previous work.
  * New upstream release. (Closes: #962820)
  * Actually enable hardened build flags. (Closes: #655864)
  * debian/control:
    - Set debhelper-compat version in Build-Depends.
    - Bump Standards-Version to 4.6.1.
    - Set Rules-Requires-Root: no.
  * debian/rules: Update to modern debhelper. (Closes: #999030, #928962)
  * debian/watch:
    - Update watch file format version to 4.
    - Opportunistically check upstream PGP signatures.
  * Use 3.0 (quilt) source format.
  * debian/copyright: Use standard, machine-readable format.
  * Fix typos in hashcash(1) man page.
  * Don't use bundled getopt.
  * Add doc-base entry.

 -- Stefan Kangas <stefankangas@gmail.com>  Tue, 11 Oct 2022 16:21:51 +0200

hashcash (1.21-2) unstable; urgency=medium

  * QA upload.
  * Set Debian QA Group as maintainer (See: #831803)
  * Update DH level to 10. (Closes: #817490)
  * debian/compat: updated to 10.
  * debian/control:
     - Bumped Standards-Version to 3.9.8.

 -- Giovani Augusto Ferreira <giovani@riseup.net>  Thu, 15 Dec 2016 10:48:59 -0200

hashcash (1.21-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Enable hardened build flags (Closes: #655864)

 -- Moritz Muehlenhoff <jmm@debian.org>  Sun, 08 Apr 2012 12:24:59 +0200

hashcash (1.21-1) unstable; urgency=low

  * New upstream release.
  * Fix copyright file.

 -- Hubert Chan <hubert@uhoreg.ca>  Thu, 30 Mar 2006 21:01:13 -0700

hashcash (1.20-1) unstable; urgency=low

  * New upstream release.
  * Set DEB_HOST_ARCH if it is not set, so that debian/rules works properly
    even if not run form dpkg-buildpackage.
  * Bump standards version to 3.6.2.

 -- Hubert Chan <hubert@uhoreg.ca>  Thu, 22 Dec 2005 00:00:43 -0500

hashcash (1.17-1) unstable; urgency=low

  * New upstream release.
    * Adds hashfork.py script to run multiple instances of Hashcash on
      multiprocessor machines.  (closes: 281918)

 -- Hubert Chan <hubert@uhoreg.ca>  Wed, 30 Mar 2005 15:07:08 -0500

hashcash (1.13-1) unstable; urgency=low

  * New upstream release.
  * Fix compile flags for amd64 architecture so that it compiles.
    (closes: 278047)

 -- Hubert Chan <hubert@uhoreg.ca>  Thu,  4 Nov 2004 17:41:28 -0500

hashcash (1.12-1) unstable; urgency=low

  * New upstream release. (closes: 271635)
  * Add architecture-dependent flags in debian/rules to enable assembly
    optimizations.
  * New license from upstream.

 -- Hubert Chan <hubert@uhoreg.ca>  Fri,  8 Oct 2004 23:17:32 -0400

hashcash (1.01-1) unstable; urgency=low

  * New upstream release.
  * Clarified license as per upstream.
  * Compile with -Wall.

 -- Hubert Chan <hubert@uhoreg.ca>  Sun,  8 Aug 2004 19:31:43 -0400

hashcash (1.00-1) unstable; urgency=low

  * New upstream release.
  * This release adds the new stamp format.  (closes: 239157)
  * Update of Kyle Hasselbacher's scripts.
  * Add link to the hashcash-sendmail page in copyright file and in
    hashcash-sendmail.txt.
  * New license from upstream.
  * Add rule to debian/rules to rebuild documentation if needed.
  * Apply patch from Justin to fix segfault when checking future version
    stamps.

 -- Hubert Chan <hubert@uhoreg.ca>  Sun,  8 Aug 2004 00:09:33 -0400

hashcash (0.32-1) unstable; urgency=low

  * New upstream release.
  * Updated copyright file to add new request by author.
  * Change upstream website in copyright file to reflect new address.
  * Add Kyle Hasselbacher's hashcash-sendmail and hashmail-request scripts
    (ALPHA) to examples directory.

 -- Hubert Chan <hubert@uhoreg.ca>  Wed, 26 May 2004 23:47:13 -0400

hashcash (0.28-4) unstable; urgency=low

  * Remove beginning "a" from package description.
  * Fixed typos in changelog, and improved consistency.
  * Re-add fip180-1.txt to source package.  (Not needed for binary
    package.)  All FIPS are public domain worldwide, as per discussion on
    debian-legal.
    http://lists.debian.org/debian-legal/2004/debian-legal-200403/msg00028.html

 -- Hubert Chan <hubert@uhoreg.ca>  Thu,  4 Mar 2004 15:42:31 -0500

hashcash (0.28-3) unstable; urgency=low

  * Don't install sha1 or sha1.1.  Debian already has sha1sum.
  * Remove fip180-1.txt -- copyright status uncertain.
  * Fix the copyright file to make it clear that Debian does not
    specifically make the same pledges that upstream does.

 -- Hubert Chan <hubert@uhoreg.ca>  Fri, 27 Feb 2004 21:16:19 -0500

hashcash (0.28-2) unstable; urgency=low

  * Bump policy version to 3.6.1.
  * Add note to copyright file about getopt being GPL licensed.

 -- Hubert Chan <hubert@uhoreg.ca>  Sun, 22 Feb 2004 21:32:22 -0500

hashcash (0.28-1) unstable; urgency=low

  * Initial Release. (closes: 234743)

 -- Hubert Chan <hubert@uhoreg.ca>  Sat, 27 Dec 2003 15:23:30 -0500

=== debian/control ===
Source: hashcash
Section: mail
Priority: optional
Standards-Version: 4.6.1
Maintainer: Stefan Kangas <stefankangas@gmail.com>
Build-Depends:
 debhelper-compat (= 13),
Rules-Requires-Root: no
Homepage: http://hashcash.org/
Vcs-Browser: https://salsa.debian.org/skangas/hashcash
Vcs-Git: https://salsa.debian.org/skangas/hashcash.git -b debian/latest

Package: hashcash
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: postage payment scheme for email based on hash calculations
 Hashcash is a payment scheme that uses CPU cycles as the form of payment.
 This can be used as a counter-measure for junk email (spam) by using the
 hashcash token as a proof of payment for each email that you sent.

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

OPTFLAGS = -O3 -funroll-loops

ifeq ($(DEB_HOST_ARCH),amd64)
OPTFLAGS = -O3 -funroll-loops -D_REENTRANT -D_THREAD_SAFE -fPIC
endif

ifeq ($(DEB_HOST_ARCH),i386)
OPTFLAGS = -O3 -funroll-loops -march=i386 -mcpu=i486 -mmmx \
	-D_REENTRANT -D_THREAD_SAFE -fPIC
endif

ifeq ($(DEB_HOST_ARCH),powerpc)
OPTFLAGS = -O3 -funroll-loops -fno-inline -mcpu=powerpc -maltivec \
	-mabi=altivec
endif

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = $(OPTFLAGS) -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

execute_after_dh_auto_clean:
	rm -f hashcash libhashcash.a

=== debian/watch ===
version=4
options="pgpmode=auto, \
         uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|pr)\d*)$/$1~$2/" \
http://hashcash.org/source/hashcash-(.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
